#!/usr/bin/perl -w

do '../web-lib.pl';
&init_config();

our ( %in, %text ) ;
&ReadParse();
&header("", "", undef, 0, 1, 0);

use strict ;
use Data::Dumper;

#################################################
## Constante
#################################################
my $repo_proj	= "/mnt/raid/svn/projets/debian" ;
my $control	= "current/DEBIAN/control" ;
my $version	= "version" ;

my $repo_paquet	= "/mnt/raid/repository/dists/Intellique";
my $archi	= "binary-i386";
my $unstable	= "unstable";

my $cmd_mkpack	= "/usr/lib/cgi-bin/svn/my_mkpack.pl";

my @list_repo	= ( 'stable', 'testing', 'unstable');

#################################################

my $paquet = $in{paquet} ;

if ( ! $paquet ) {
	print <<EOF;
<table valign=top width=100%>
    <tr>
        <th align=center>
	PUE DU CUL
	</th>
    </tr>
</table>
EOF
}
elsif ( $in{package} ) {
	# Lance une procedure de creation de tous les Package.gz
	my @ret = `$cmd_mkpack`;

	print "<table valign=top width=100%><tr style=\"font:Arial;font-size: 16pt; font-weight: bold; text-decoration: none; color : green\">";
	print "<td>Creation des packages.gz Effectue avec succes !!</td>";
	print "</tr>";
	print "<tr style=\"font:Arial;font-size: 12pt; font-weight: bold; text-decoration: none; color : green\"><td>";
	foreach (@ret) {
		print "$_<br>";
	}
	print "</td></tr></table>";

}
else {
	#gere la demande de l utilisateur pour un paquet precis
	print <<EOF;
<h2 style=\"color : green\">$paquet</h2>
EOF
	
### Verfication de l etat du paquet
	my $etat_svn = `wget http://basson/svn/debian/$paquet/ --output-document=/dev/null -q ; echo \$\?`;
	chomp $etat_svn;
	if ( $etat_svn ) {
		print "<br><h2 style=\"color : red\">Le paquet $paquet est endommage. Veuillez faire une rcupration. Merci.<br>Pour cela, cliquez ";
		print "<a href=\"action.cgi?paquet=$paquet&recovery=1\"><b>ici</b></td></a>";
		print " !!!</h2>";

	
	}

### Recuperation des infos du paquet
	print "<br>Informations sur le paquet $paquet extrait du fichier de control de la section 'current'<br>";

	my @control	= `cat $repo_proj/$paquet/$control `;
	print "<table valign=top width=100%>" ;
	foreach my $line ( @control ) {
		chomp $line ;
		if ( $line =~ /(.*):(.*)/ ) {
			print "<tr><td width=20>&nbsp;</td><td align=left width=120>$1</td><td align=left>$2</td></tr>";
		}
		else {
			print "<tr><td width=20>&nbsp;</td><td align=left width=120>&nbsp;</td><td align=left>$line</td></tr>";
		}
	}
	print "</table>";

### Recuperation de la liste des versions pour stable, testing et unstable
	my $affichage = "";
	my %hash_paquets;
	foreach my $repo ( @list_repo ) {
		chomp $repo ;
		map { push @{ $hash_paquets{$1} }, $repo if ( $_ =~ /^$paquet\_([0-9.-]*)\_/ ) } `ls -1 $repo_paquet/$repo/$archi/` ;
		map { push @{ $hash_paquets{$repo} }, $_ if ( $_ =~ /^$paquet\_([0-9.-]*)\_/ ) } `ls -1 $repo_paquet/$repo/$archi/` ;
	}
delete $hash_paquets{'stable'};
delete $hash_paquets{'testing'};

	foreach my $line ( `ls -1 $repo_proj/$paquet/$version 2>/dev/null` ) {
		chomp $line ;
		if ( exists $hash_paquets{$line} ) {
			$affichage .= "<tr><td width=20>&nbsp;</td><td align=left width=120>$line</td><td>". (join " ", @{ $hash_paquets{$line} } )."</td></tr>";
			delete $hash_paquets{$line};
		}
	}

	if ( $affichage ) {
		print "<br><br>Liste des versions pouvant gnres un paquet debian stable ou testing<br>";
		print "<table valign=top width=100%>" ;
		print $affichage ;
		print "</table>";
	}

### Recuperation de la liste des versions pour unstable
	if ( exists $hash_paquets{$unstable} ) {
		print "<br><br>Liste des paquets dans le repository 'unstable'<br>";
		print "<table valign=top width=100%>" ;
		foreach my $line ( sort @{ $hash_paquets{$unstable} } ) {
			print "<tr><td width=20>&nbsp;</td><td align=left width=120>$line</td><td></td></tr>";
		}
		print "</table>";
		delete $hash_paquets{$unstable};
	}

### Recuperation de la liste des trucs poss  la main
	if ( keys %hash_paquets ) {	
		print "<br>Liste des paquets qui trainent<br>";
		print "<table valign=top width=100%>" ;
		foreach my $k ( keys %hash_paquets ) {
			print "<tr><td width=20>&nbsp;</td><td align=left width=120>$k</td><td>". (join " ", @{ $hash_paquets{$k} } ) ."</td></tr>";
		}
		print "</table>";
	}


### Bouton d'action en fin de page
	print <<EOF;
<table valign=top width=100%>
	<form action="action.cgi">
		<input type=hidden name=paquet value=$paquet>
		<tr><td>&nbsp;</td></tr>
		<tr><td width=20>&nbsp;</td><td align=left width=120><input name="update" value="Faire un update des sources" type="submit"></td><td width=20>&nbsp;</td>
		    <td>Cliquez sur ce bouton pour faire un update des sources du paquet.</td></tr>
		<tr><td width=20>&nbsp;</td><td align=left width=120><input name="unstable" value="Crer un paquet 'unstable'" type="submit"></td><td width=20>&nbsp;</td>
		    <td>Cliquez sur ce bouton pour crer un paquet debian dans le repository 'unstable'.</td></tr>
EOF
	
	if ( $ENV{'REMOTE_USER'} eq 'root' ) {
		print <<EOF;
		    <tr><td width=20>&nbsp;</td></tr>
		<tr><td width=20>&nbsp;</td><td align=left width=120><input name="go_to_testing"  value="'unstable' vers 'testing'  " type="submit"></td><td width=20>&nbsp;</td>
		    <td>Cliquez sur ce bouton pour passer les sources "unstable' en 'testing'.</td></tr>
		<tr><td width=20>&nbsp;</td><td align=left width=120><input name="testing"  value="Crer un paquet 'testing'  " type="submit"></td><td width=20>&nbsp;</td>
		    <td>Cliquez sur ce bouton pour crer un paquet debian dans le repository 'testing'.</td></tr>
EOF
	}

	print <<EOF;
	</form>
</table>
EOF

}

print <<EOF;
<table valign=top width=100%>
	<tr><td>&nbsp;</td></tr>
	<tr><td>&nbsp;</td></tr>
	<tr><td>&nbsp;</td><td align=left><a href=\"index.cgi\">Revenir  l'acceuil</a></td></tr>
</table>
EOF

########################
# Fin

&footer("/", $text{'index'});
