#!/usr/bin/perl -w

do '../web-lib.pl';
&init_config();

our ( %in, %text ) ;
&ReadParse();
&header("", "", undef, 0, 1, 0);

use strict ;
use Data::Dumper;
use List::Util qw ( maxstr );

#################################################
## Constante
#################################################
my $repo_proj	= "/mnt/raid/svn/projets/debian" ;
my $control	= "current/DEBIAN/control" ;
my $version	= "version" ;

my $repo_paquet	= "/mnt/raid/repository/dists/Intellique";
my $archi	= "binary-i386";
my $unstable	= "unstable";
my @list_repo	= ( 'stable', 'testing', 'unstable');

#################################################

my $rep_svn = "/mnt/raid/svn/debian/";

my %list_deb;
foreach my $repo ( @list_repo ) {
	my @tt = `ls -1 $repo_paquet/$repo/$archi/`;
	$list_deb{$repo} = \@tt;
}

# Listage du dossier /mnt/repository/svn
my @list = `ls -1 $rep_svn`;
chomp @list;

print <<EOF;
<a href=\"index.cgi\">Revenir  l'acceuil</a><br>
EOF


#@list = ( "raid-cli", "storiq-nv-replicator64", "open-iscsi" );


foreach my $paquet ( @list ) {
	next unless (-d $rep_svn.$_);

### Recuperation de la version max pour creer un paquet testing
	my $max_version_svn = maxstr( `ls -1 $repo_proj/$paquet/$version 2>/dev/null` );

### Recuperation de la version current dans le svn
	my $current_svn = "";
	grep {	$current_svn = $1 if ( $_ =~ /Version:(.*)/ ) } `grep Version $repo_proj/$paquet/$control`;

### Recuperation de la liste des versions pour stable, testing et unstable
	my %hash_paquets_repo_vers;
	my %hash_paquets_repo_nom;
	foreach my $repo ( @list_repo ) {
		map { $hash_paquets_repo_vers{$1}{$repo} = "" if ( $_ =~ /^$paquet\_([0-9a-wA-W.-]*)\_/ ) } @{ $list_deb{$repo} };
	}

#print "<pre>";
#print Dumper \%hash_paquets_repo_vers;
#print "</pre>";

	print <<EOF;
<br>$paquet<br>
<table valign=top>
	<tr><td width=60>&nbsp;</td><td align=left>Version current svn :&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$current_svn</td></tr>
	<tr><td width=60>&nbsp;</td><td align=left>Version max pour testing :&nbsp;&nbsp;&nbsp;$max_version_svn</td></tr>
	<tr><td width=60>&nbsp;</td><td align=left>Paquet Debian : </td></tr>
	<tr><td width=60>&nbsp;</td><td>
		<table valign=top>
EOF

	foreach my $version ( sort {$b cmp $a} keys %hash_paquets_repo_vers ) {
		my ( $stable, $testing, $unstable ) = ("stable", "testing", "unstable");
		$stable   = "" unless ( exists $hash_paquets_repo_vers{ $version }{ 'stable' } );
		$testing  = "" unless ( exists $hash_paquets_repo_vers{ $version }{ 'testing' } );
		$unstable = "" unless ( exists $hash_paquets_repo_vers{ $version }{ 'unstable' } );

		print <<EOF;
		<tr>
			<td width=60>&nbsp;</td><td align=left width=180>$version</td>
			<td width=120>$stable</td>
			<td width=120>$testing</td>
			<td width=120>$unstable</td>
		</tr>
EOF
	}

	print <<EOF;
		</table>
	</td></tr>
</table>
EOF

}

print <<EOF;
<br><br>
<a href=\"index.cgi\">Revenir  l'acceuil</a>
EOF

########################
# Fin

&footer("/", $text{'index'});
