#!/usr/bin/perl
## ######### PROJECT NAME : ##########
##
## create_package.pl for
##
## ######### PROJECT DESCRIPTION : ###
##
##
##
## ###################################
##
## Made by Boutonnet Alexandre
## Login   <aboutonnet@intellique.com>
##
## Started on  Tue Apr 28 18:01:02 2009 Boutonnet Alexandre
## Last update Thu Apr 30 16:32:53 2009 Boutonnet Alexandre
##
## ###################################
##

use strict;
use warnings;

use lib "./lib";
use BBInit;
require paths;

use deb_package;

Lib_CGI::new_cgi();
Lib_CGI::print_html_header();

my $svn_package  = Lib_CGI::get_param('package');
my $category     = Lib_CGI::get_param('category');
my $package_type = Lib_CGI::get_param('type');
my $back_page    = Lib_CGI::get_param('back_page');
my $version      = Lib_CGI::get_param('version');

if (   !defined($category)
    || !grep( /^$category$/, @$PATHS::SVN_REPOSITORIES ) )
{
    print "Unknown category..<br/>";
    exit 0;
}

if ( $package_type eq "unstable" ) {
    my $error_msg =
        DebPackage::create_unstable_package( $category, $svn_package );
    if ($error_msg) {
        print "FAIL !!<br/>";
        print "<pre>$error_msg</pre><br/>";
    }
    else {
        print "OK !!<br/>";
        my $redirect = "index.cgi";

        $redirect = "svn_detail.cgi?category=$category&package=$svn_package"
            if ( $back_page eq "detail" );

        print "<A HREF=\"$redirect\">Ok<A />";

        # redirection automatique en javascript..
        # print "<script type=\"text/javascript\">
        # <!--
        # window.location = \"$redirect\"
        # //-->
        # </script>";
    }
}
elsif ( $package_type eq "testing" ) {
    if ( !defined($version) ) {
        print "Unknown category..<br/>";
        exit 0;
    }

    my $error_msg =
        DebPackage::create_testing_package( $category, $svn_package,
        $version );
    if ($error_msg) {
        print "FAIL !!<br/>";
        print "<pre>$error_msg</pre><br/>";
    }
    else {
        print "OK !!<br/>";
        my $redirect = "index.cgi";

        $redirect = "svn_detail.cgi?category=$category&package=$svn_package"
            if ( $back_page eq "detail" );

        print "<A HREF=\"$redirect\">Ok<A />";

        # redirection automatique en javascript..
        # print "<script type=\"text/javascript\">
        # <!--
        # window.location = \"$redirect\"
        # //-->
        # </script>";
    }

}
else {
    print "Unknown package type..<br/>";
    exit 0;
}
