#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
##
## svn_detail.pl for
##
## ######### PROJECT DESCRIPTION : ###
##
##
##
## ###################################
##
## Made by Boutonnet Alexandre
## Login   <aboutonnet@intellique.com>
##
## Started on  Wed Apr 29 11:14:47 2009 Boutonnet Alexandre
## Last update Thu Apr 30 16:46:26 2009 Boutonnet Alexandre
##
## ###################################
##

use strict;
use warnings;

use Data::Dumper;

use lib "./lib";
use BBInit;
require paths;

use deb_package;

Lib_CGI::new_cgi();
Lib_CGI::print_html_header();
Lib_TT::new_tt('templates/');

my $svn_package = Lib_CGI::get_param('package');
my $category    = Lib_CGI::get_param('category');

if (   !defined($category)
    || !grep( /^$category$/, @$PATHS::SVN_REPOSITORIES ) )
{
    print "Unknown category..<br/>";
    exit 0;
}

my @control_content =
  `cat $PATHS::PROJECT_PATH$category\/$svn_package\/current\/DEBIAN\/control`;

my $control_tab = ();
my $hash        = {};
foreach my $line (@control_content) {
    if ( $line !~ m/^\s.+/ ) {
        my ($key)   = ( $line =~ m/^(\w+)\:/ );
        my ($value) = ( $line =~ m/\:(.+)/ );
        $hash->{$key} = $value;
        push @$control_tab, $key;
    } else {
        $hash->{'Description'} .= "<br/>" . $line;
    }
}
Lib_TT::set( "section_list", $control_tab );
Lib_TT::set( "section_hash", $hash );
Lib_TT::set( "link_update",
    "svn_update.cgi?category=$category&package=$svn_package&back_page=detail" );
Lib_TT::set( "link_unstable",
"create_package.cgi?category=$category&package=$svn_package&type=unstable&back_page=detail"
);
Lib_TT::set( "link_branch",
    "create_branch.cgi?category=$category&package=$svn_package&back_page=detail"
);
Lib_TT::set( "link_log",
    "svn_log.cgi?category=$category&package=$svn_package&back_page=detail"
);

# I get all release path
my $testing_release =
  `echo -n $PATHS::PROJECT_PATH$category\/$svn_package\/version\/*`;
my @testing_release_list = split( / /, $testing_release );

my $return_tab = ();

foreach my $release_path (@testing_release_list) {
    next if ( $release_path =~ m/.+\*$/ );

    my $tmp_hash = {};

    ( $tmp_hash->{'version'} ) = ( $release_path =~ m/.+\/(.+)$/ );
    $tmp_hash->{'build_link'} =
"create_package.cgi?category=$category&package=$svn_package&type=testing&back_page=detail&version=$tmp_hash->{'version'}";

    # I seek all already build packages
    my $seek_path =
        "$PATHS::REPOSITORY_PATH/pool/*/*/*/"
      . $svn_package . "_"
      . $tmp_hash->{'version'}
      . "_*.deb";

    my $all_packages = `echo -n $seek_path`;
    my @packages_tab = split( / /, $all_packages );

    $tmp_hash->{'packages'} = ();

    foreach my $pack (@packages_tab) {
        next if ( !-f $pack );
        my ( $distro, $status ) = ( $pack =~ m(/pool/(\w+)/(\w+)/) );
        push( @{ $tmp_hash->{'packages'} }, "$distro $status" );
    }

    # print "<pre>";
    # print Dumper $tmp_hash;
    # print "</pre>";

    push( @$return_tab, $tmp_hash );
}

Lib_TT::set( "releases", $return_tab );

Lib_TT::process("detail.tt");
