package Lib_BDD;

use DBI;

my $dbi;

my $dbname = "bambooweb";
my $host = "localhost";

my $source = "dbi:Pg:dbname=$dbname;host=$host";

# Fonction de connection a la base de donnee..
# Cette fonction peut etre appellee plusieurs fois..
sub bdd_connect
{
	if (!defined($dbi))
	{
		$dbi = DBI->connect($source, "alex", "jwvy_+bC")
		or die "Failed to connect to database: $DBI::errstr";
	}
    return 0;
}

# Fonction de desconnection de la base.. (untested)
sub bdd_disconnect
{
	if (defined($dbi))
	{
		$dbi->disconnect()
		or die "Failed to disconnect to database: $DBI::errstr";
	}
	return 0;
}

# Fonction de recuperation du resultat d'une requette sous forme
# d'une hash..
sub get_hash
{
	my $statement = shift;
	my $key_field = shift;
	return $dbi->selectall_hashref($statement, $key_field, {}, @_);
}

# Fonction qui renvoie la premiere ligne d'une requette sous forme
# d'une ref d'un tableau
# Prend en param la requette et les parametres
# ex . ('UPDATE... = ?', $value)
sub get_first_row_array
{
	my $statement = shift;
	my $tab = $dbi->selectall_arrayref($statement, {"Slice"=>"0"}, @_);
	return @$tab[0] if (scalar(@$tab));
	return 0;
}

sub get_hash_row
{
    my $request = shift;

    my $req = $dbi->prepare($request);
    $req->execute();
    #my $hash = $req->fetchall_hashref('id');
	my $hash = $req->fetchall_arrayref();
    $req->finish();

    return $hash;
}

sub get_first_row
{
    my $db = shift;
    my $request = shift;

    my $req = $dbi->prepare($request);
    $req->execute();
    my ($row) = $req->fetchrow_array();
    $req->finish();

    return $row;
}

sub get_all_rows
{
    my $db = shift;
    my $request = shift;
    
    my $req = $dbi->prepare($request);
    $req->execute();
    my @tab = @{$req->fetchall_arrayref()};
    $req->finish();
    
    return @tab;
}

sub get_hash_rows
{
    my ($db, $request, $key) = @_;
    
    my $req = $db->prepare($request);
    $req->execute();
    my $hash = $req->fetchall_hashref($key);
    $req->finish();
    
    return $hash;
}

sub do_request
{
	my $request = shift;
	my $sth = $dbi->prepare($request);
	$sth->execute(@_) or return $sth->errstr;
	return 0;
}

1;
